Index: trunk/SophyaLib/Samba/localmap.cc
===================================================================
--- trunk/SophyaLib/Samba/localmap.cc	(revision 681)
+++ trunk/SophyaLib/Samba/localmap.cc	(revision 682)
@@ -27,727 +752,2 @@
 template class FIO_LocalMap< complex<double> >;
 #endif
-
-//*****************************************************************************
-//++ 
-// Class	LocalMap
-//
-// include      localmap.h nbmath.h
-//
-//    A local map of a region of the sky, in cartesian coordinates.
-//    It has an origin in (theta0, phi0), mapped to pixel(x0, y0)
-//    (x0, y0 might be outside of this local map)
-//    default value of (x0, y0) is middle of the map, center of 
-//    pixel(nx/2, ny/2)
-//
-//    A local map is a 2 dimensional array, with i as column index and j
-//    as row index. The map is supposed to lie on a plan tangent to the 
-//    celestial sphere in a point whose coordinates are (x0,y0) on the local
-//    map and (theta0, phi0) on the sphere. The range of the map is defined
-//    by two values of angles covered respectively by all the pixels in 
-//    x direction and all the pixels in y direction (SetSize()).
-//
-//    A "reference plane" is considered : this plane is tangent to the 
-//    celestial sphere in a point with angles theta=Pi/2 and phi=0. This 
-//    point is the origine of coordinates is of the reference plane. The 
-//    x-axis is the tangent parallel to the equatorial line and oriented 
-//    toward the increasing phi's ; the y-axis is parallel to the meridian 
-//    line and oriented toward the north pole.
-//    
-//    Internally, a map is first defined within this reference plane and
-//    tranported until the point (theta0, phi0) in such a way that both 
-//    axes are kept parallel to meridian and parallel lines of the sphere.
-//    The user can define its own map with axes rotated with respect to
-//    reference axes (this rotation is characterized by angle between 
-//    the local parallel line and the wanted x-axis-- see method 
-//    SetOrigin(...))
-//    
-//
-
-//
-//-- 
-//++
-//
-// Links	Parents
-//
-//    PixelMap
-//    
-//-- 
-//++
-//
-// Links	Childs
-//
-//     
-//-- 
-//++
-// Titre	Constructors
-//--
-//++
-template<class T>
-LocalMap<T>::LocalMap()
-//
-//     
-//--
-{
-  InitNul();
-  pixels_.Reset();
-}
-
-//++
-template<class T>
-LocalMap<T>::LocalMap(int nx, int ny) : nSzX_(nx), nSzY_(ny)
-//
-//    
-//--
-{
-  InitNul();
-  nPix_= nx*ny;
-  pixels_.ReSize(nPix_);
-  pixels_.Reset();
-}
-
-//++
-template<class T>
-LocalMap<T>::LocalMap(const LocalMap<T>& lm, bool share)
-  : pixels_(lm.pixels_, share)
-
-//
-//    copy constructor
-//--
-{
-  cout<<" LocalMap:: Appel du constructeur de recopie " << endl;
-
-  if(lm.mInfo_) mInfo_= new DVList(*lm.mInfo_);
-  nSzX_= lm.nSzX_;
-  nSzY_= lm.nSzY_;
-  nPix_= lm.nPix_;
-  originFlag_= lm.originFlag_;
-  extensFlag_= lm.extensFlag_;
-  x0_= lm.x0_;
-  y0_= lm.y0_;
-  theta0_= lm.theta0_;
-  phi0_= lm.phi0_;
-  angle_= lm.angle_;
-  cos_angle_= lm.cos_angle_;
-  sin_angle_= lm.sin_angle_;
-  angleX_= lm.angleX_;
-  angleY_= lm.angleY_;
-  tgAngleX_= lm.tgAngleX_;
-  tgAngleY_= lm.tgAngleY_;
-}
-
-//++
-// Titre	Destructor
-//--
-//++
-template<class T>
-LocalMap<T>::~LocalMap()
-//
-//--
-{
-  InitNul();
-}
-
-
-
-//++
-// Titre	Public Methods
-//--
-
-//++
-template<class T>
-void LocalMap<T>::ReSize(int nx, int ny) 
-//
-//    Resize storage area for pixels 
-//--
-{
-  InitNul();
-  nSzX_ = nx;
-  nSzY_ = ny;
-  nPix_= nx*ny;
-  pixels_.ReSize(nPix_);
-  pixels_.Reset();
-}
-
-//++
-template<class T>
-int LocalMap<T>::NbPixels() const
-//
-//    Return number of pixels
-//--
-{
-  return(nPix_);
-}
-
-//++
-template<class T>
-T& LocalMap<T>::PixVal(int k)
-//
-//    Return value of pixel with index k
-//--
-{
-  if((k < 0) || (k >= nPix_)) 
-    {
-      cout << " LocalMap::PIxVal : exceptions  a mettre en place" <<endl;
-      //  THROW(out_of_range("LocalMap::PIxVal Pixel index out of range"));
-      THROW(rangeCheckErr);
-      //throw "LocalMap::PIxVal Pixel index out of range";
-    }
-  return(pixels_(k));
-}
-
-//++
-
-template<class T>
-T const& LocalMap<T>::PixVal(int k) const
-//
-//   const version of previous method
-//--
-{
-  if((k < 0) || (k >= nPix_)) 
-    {
-      cout << " LocalMap::PIxVal : exceptions  a mettre en place" <<endl;
-      //    THROW(out_of_range("LocalMap::PIxVal Pixel index out of range"));
-      
-      throw "LocalMap::PIxVal Pixel index out of range"; 
-    } 
-  return *(pixels_.Data()+k);
-}
-
-template<class T>
-bool LocalMap<T>::ContainsSph(double theta, double phi) const
-{
-// $CHECK$  Reza 11/11/99 - A modifier
-return(true);
-}
-
-//++
-template<class T>
-int LocalMap<T>::PixIndexSph(double theta,double phi) const
-//
-//    Return index of the pixel with spherical coordinates (theta,phi)
-//--
-{
-  int i,j;
-  if(!(originFlag_) || !(extensFlag_)) 
-    {
-      cout << " LocalMap: correspondance carte-sphere non etablie" << endl;
-      exit(0);
-    }
-
-  // theta et phi en coordonnees relatives (on se ramene a une situation par rapport au plan de reference)
-  double theta_aux= theta;
-  double phi_aux  = phi;
-  UserToReference(theta_aux, phi_aux);
-
-  // coordonnees dans le plan local en unites de pixels
-  double x,y;
-  AngleProjToPix(theta_aux,phi_aux, x, y);
-
-  double xmin= -x0_-0.5;
-  double xmax= xmin+nSzX_;
-  if((x > xmax) || (x < xmin)) return(-1);
-  double xcurrent= xmin;
-  for(i = 0; i < nSzX_; i++ ) 
-    {
-      xcurrent += 1.;
-      if( x < xcurrent ) break;
-    }
-  double ymin= -y0_-0.5;
-  double ymax= ymin+nSzY_;
-  if((y >  ymax) || (y < ymin)) return(-1);
-  double ycurrent= ymin;
-  for(j = 0; j < nSzY_; j++ ) 
-    {
-      ycurrent += 1.;
-      if( y < ycurrent ) break;
-    }
-  return (j*nSzX_+i);
-}
-
-//++
-template<class T>
-void LocalMap<T>::PixThetaPhi(int k,double& theta,double& phi) const
-//
-//    Return (theta, phi) coordinates of pixel with index k
-//--
-{
-  if(!(originFlag_) || !(extensFlag_)) 
-    {
-      cout << " LocalMap: correspondance carte-sphere non etablie" << endl;
-      exit(0);
-    }
-
-  int i,j;
-  Getij(k,i,j);
-
-  double X= double(i-x0_);
-  double Y= double(j-y0_);
-  // situation de ce pixel dans le plan de reference
-  double x= X*cos_angle_-Y*sin_angle_;
-  double y= X*sin_angle_+Y* cos_angle_;
-  // projection sur la sphere
-  PixProjToAngle(x, y, theta, phi);
-  // retour au plan utilisateur
-  ReferenceToUser(theta, phi);
-}
-
-template <class T>
-T LocalMap<T>::SetPixels(T v)
-{
-pixels_.Reset(v);
-return(v);
-}
- 
-//++
-template<class T>
-double LocalMap<T>::PixSolAngle(int k) const
-//
-//    Pixel Solid angle  (steradians)
-//    All the pixels have not necessarly the same size in (theta, phi)
-//    because of the projection scheme which is not yet fixed.   
-//--
-{
-  int i,j;
-  Getij(k,i,j);
-  double X= double(i-x0_);
-  double Y= double(j-y0_);
-  double XR= X+double(i)*0.5;
-  double XL= X-double(i)*0.5;
-  double YU= Y+double(j)*0.5;
-  double YL= Y-double(j)*0.5;
-
-  // situation  dans le plan de reference
-  double x0= XL*cos_angle_-YL*sin_angle_;
-  double y0= XL*sin_angle_+YL*cos_angle_;
-  double xa= XR*cos_angle_-YL*sin_angle_;
-  double ya= XR*sin_angle_+YL*cos_angle_;
-  double xb= XL*cos_angle_-YU*sin_angle_;
-  double yb= XL*sin_angle_+YU*cos_angle_;
-
-  // projection sur la sphere
-  double thet0,phi0,theta,phia,thetb,phib;
-  PixProjToAngle(x0, y0, thet0, phi0);
-  PixProjToAngle(xa, ya, theta, phia);
-  PixProjToAngle(xb, yb, thetb, phib);
-
-  // angle solide
-  double sol= fabs((xa-x0)*(yb-y0)-(xb-x0)*(ya-y0));
-  return sol;
-}
-
-//++
-template<class T>
-void LocalMap<T>::SetOrigin(double theta0,double phi0,double angle)
-//
-//    set the referential of the map (angles in degrees)
-//    (default x0=siz_x/2,  y0=siz_y/2) 
-//--
-{
-  theta0_= theta0;
-  phi0_  = phi0;
-  angle_ = angle;
-  x0_= nSzX_/2;
-  y0_= nSzY_/2;
-  cos_angle_= cos(angle*Pi/180.);
-  sin_angle_= sin(angle*Pi/180.);
-  originFlag_= true; 
-  cout << " LocalMap:: set origin 1 done" << endl;
-}
- 
-//++
-template<class T>
-void LocalMap<T>::SetOrigin(double theta0,double phi0,int x0,int y0,double angle)
-//
-//    set the referential of the map (angles in degrees)
-//--
-{
-  theta0_= theta0;
-  phi0_  = phi0;
-  angle_ = angle;
-  x0_= x0;
-  y0_= y0;
-  cos_angle_= cos(angle*Pi/180.);
-  sin_angle_= sin(angle*Pi/180.);
-  originFlag_= true;
-  cout << " LocalMap:: set origin 2 done" << endl;
-} 
-
-//++
-template<class T>
-void LocalMap<T>::SetSize(double angleX,double angleY)
-//
-//    angle range of tthe map (angles in degrees)
-//--
-{
-  angleX_= angleX;
-  angleY_= angleY;
-
-  // tangente de la moitie de l'ouverture angulaire totale
-  tgAngleX_= tan(0.5*angleX_*Pi/180.);
-  tgAngleY_= tan(0.5*angleY_*Pi/180.);
-
-  extensFlag_= true;
-  cout << " LocalMap:: set extension done" << endl;
-}
-
-//++
-template<class T>
-void LocalMap<T>::Project(SphericalMap<T>& sphere) const
-//
-//    Projection to a spherical map   
-//--
-{
-  for(int m = 0; m < nPix_; m++) 
-    {
-      double theta,phi;
-      PixThetaPhi(m,theta,phi);
-      sphere(theta,phi)= pixels_(m);
-      // cout << "theta " << theta << " phi " << phi << " valeur " << sphere(theta,phi)<< endl;
-    }
-}
-// Titre	Private Methods
-//++
-template<class T>
-void LocalMap<T>::InitNul()
-//
-//    set some attributes to zero
-//--
-{ 
-  originFlag_= false;
-  extensFlag_= false;
-  cos_angle_= 1.0;
-  sin_angle_= 0.0;
-//  pixels_.Reset(); Pas de reset par InitNul (en cas de share) - Reza 20/11/99 $CHECK$
-}
-
-//++
-template<class T>
-void LocalMap<T>::Getij(int k,int& i,int& j) const
-//
-//    Return 2 indices corresponding to the pixel number k
-//--
-{
-  i= (k+1)%nSzX_-1;
-  if(i == -1) i= nSzX_-1;
-  j= (k-i+2)/nSzX_;
-}
-
-//++
-template<class T>
-void  LocalMap<T>::ReferenceToUser(double& theta,double& phi) const
-//
-//    Transform a pair of coordinates (theta, phi) given in 
-//    reference coordinates into map coordinates
-//--     
-{
-  if(theta > Pi || theta < 0. || phi < 0. || phi >= 2*Pi) 
-    {
-      throw "LocalMap::ReferenceToUser (theta,phi) out of range"; 
-    } 
-
-  theta= theta0_*Pi/180.+theta-Pi*0.5;
-  if(theta < 0.) 
-    {
-      theta= -theta;
-      phi += Pi;
-    } 
-  else 
-    {
-      if(theta > Pi) 
-	{
-	  theta= 2.*Pi-theta;
-	  phi += Pi;
-	} 
-    }
-
-  phi= phi0_*Pi/180.+phi;
-  while(phi >= 2.*Pi) phi-= 2.*Pi;
-
-  if(theta > Pi || theta < 0. || phi < 0. || phi >= 2*Pi) 
-    {
-      cout <<  " LocalMap::ReferenceToUser : erreur bizarre dans le transfert a la carte utilisateur " << endl;
-      cout << " theta= " << theta << " phi= " << phi << endl;
-      exit(0);
-    }
-}
-
-//++
-template<class T>
-void  LocalMap<T>::UserToReference(double& theta,double& phi) const
-//
-//    Transform a pair of coordinates (theta, phi) given in 
-//    map coordinates into reference coordinates
-//--     
-{
-  if(theta > Pi || theta < 0. || phi < 0. || phi >= 2*Pi) 
-    {
-      cout<<" LocalMap::UserToReference: exceptions a mettre en place" <<endl;
-      // THROW(out_of_range("LocalMap::PIxVal Pixel index out of range"));
-      throw "LocalMap::UserToReference (theta,phi) out of range"; 
-    }
-
-  double phi1= phi-phi0_*Pi/180.;
-  if(phi1 < 0.) phi1+= 2.*Pi;
-
-  double theta1= theta-theta0_*Pi/180.+Pi*0.5;
-  if(theta1 < 0.) 
-    {
-      theta= -theta1;
-      phi1+= Pi;
-    } 
-  else
-    { 
-      if(theta1 > Pi) 
-	{
-	  theta= 2.*Pi-theta1;
-	  phi1+= Pi;
-	}
-    }
-
-  while(phi1 >= 2.*Pi) phi1-= 2.*Pi;
-  phi= phi1;
-  if(theta > Pi || theta < 0. || phi < 0. || phi >= 2*Pi) 
-    {
-      cout <<  " LocalMap::UserToReference : erreur bizarre dans le transfert a la carte de reference " << endl;
-      cout << " theta= " << theta << " phi= " << phi << endl;
-      exit(0);
-    }
-}
-
-//++
-template<class T>
-void LocalMap<T>::PixProjToAngle(double x,double y,double& theta,double& phi) const
-//
-//  
-//    Given coordinates in pixel units in the REFERENCE PLANE, return
-//    (theta, phi) in "absolute" referential theta=pi/2 ,phi=0.   
-//--
-{
-  theta= Pi*0.5-atan(2.*y*tgAngleY_/(double)nSzY_);
-  phi= atan2(2.*x*tgAngleX_,(double)nSzX_);
-  if(phi < 0.) phi += DeuxPi;
-}
-
-//++
-template<class T>
-void LocalMap<T>::AngleProjToPix(double theta,double phi,double& x,double& y) const
-//
-//    Given coordinates  (theta, phi) in "absolute" referential 
-//    theta=pi/2 ,phi=0  return pixel indices  (i,j) in the REFERENCE PLANE.
-//--
-{
-  if(phi >= Pi) phi-= DeuxPi;
-  //  y=0.5*mSzY_*cot(theta)/tgAngleY_;  $CHECK-REZA-04/99$
-  y= 0.5*nSzY_/tan(theta)/tgAngleY_;  // ? cot = 1/tan ?  
-  x= 0.5*nSzX_*tan(phi)/tgAngleX_;
-}
-
-template<class T>
-void LocalMap<T>::print(ostream& os) const
-{
-  os<<" SzX= "<<nSzX_<<", SzY= "<<nSzY_<<", NPix= "<<nPix_<<endl;
-  if(LocalMap_isDone())
-    {
-      os<<" theta0= "<<theta0_<<", phi0= "<<phi0_<<", angle= "<<angle_<<endl;
-      os<<" x0= "<<x0_<<", y0= "<<y0_<<endl;
-      os<<" cos= "<<cos_angle_<<", & sin= "<<sin_angle_<<endl;
-      os<<" angleX= "<<angleX_<<", angleY= "<<angleY_<<endl;
-      os<<" tg(angleX)= "<<tgAngleX_<<", tg(angleY)= "<<tgAngleY_<<endl;
-    }
-
-  os << " contenu de pixels : ";
-  for(int i=0; i < nPix_; i++)
-    {
-      if(i%5 == 0) os << endl;
-      os <<  pixels_(i) <<", ";
-    }
-  os << endl;
-}
-//++
-// Titre	class FIO_LocalMap
-//    Delegated objects for persitance management
-//--
-
-//*******************************************************************
-// class FIO_LocalMap<T>
-//  Les objets delegues pour la gestion de persistance 
-//*******************************************************************
-
-//++
-template <class T>
-FIO_LocalMap<T>::FIO_LocalMap()
-//
-//--
-{
-  dobj= new LocalMap<T>;
-  ownobj= true;
-}
-//++
-template <class T>
-FIO_LocalMap<T>::FIO_LocalMap(string const& filename)
-//
-//--
-{
-  dobj= new LocalMap<T>;
-  dobj->DataBlock().SetTemp(true);
-  ownobj= true;
-  Read(filename);
-}
-
-//++
-template <class T>
-FIO_LocalMap<T>::FIO_LocalMap(const LocalMap<T>& obj)
-//
-//--
-{
-  dobj= new LocalMap<T>(obj, true);
-  dobj->DataBlock().SetTemp(true);
-  ownobj= true;
-}
-
-template <class T>
-FIO_LocalMap<T>::FIO_LocalMap(LocalMap<T>* obj)
-{
-  dobj= obj;
-  ownobj= false;
-}
-
-//++
-template <class T>
-FIO_LocalMap<T>::~FIO_LocalMap()
-//
-//--
-{
-  if (ownobj && dobj) delete dobj;
-}
-//++
-template <class T>
-AnyDataObj* FIO_LocalMap<T>::DataObj()
-//
-//--
-{
-  return(dobj);
-}
-
-//++
-template <class T>
-void FIO_LocalMap<T>::ReadSelf(PInPersist& is)
-//
-//--
-{
-
-  if(dobj == NULL) 
-    {
-      dobj= new LocalMap<T>;
-      dobj->DataBlock().SetTemp(true);
-      ownobj= true;
-    }
-
-  // Pour savoir s'il y avait un DVList Info associe
-  char strg[256];
-  is.GetLine(strg, 255);
-  bool hadinfo= false;
-  if(strncmp(strg+strlen(strg)-7, "HasInfo", 7) == 0)  hadinfo= true;
-  if(hadinfo) 
-    {    // Lecture eventuelle du DVList Info
-      is >> dobj->Info(); 
-    }
-
-  int nSzX;
-  is.GetI4(nSzX);
-  dobj->setSize_x(nSzX);
-
-  int nSzY;
-  is.GetI4(nSzY);
-  dobj->setSize_y(nSzY);
-
-  int nPix;
-  is.GetI4(nPix);
-  dobj->setNbPixels(nPix);
-
-  string ss("local mapping is done");
-  string sso;
-  is.GetStr(sso);
-  if(sso == ss)
-    {
-      cout<<" ReadSelf:: local mapping"<<endl;
-      int x0, y0;
-      double theta, phi, angle;
-      is.GetI4(x0);
-      is.GetI4(y0);
-      is.GetR8(theta);
-      is.GetR8(phi);
-      is.GetR8(angle);
-      dobj->SetOrigin(theta, phi, x0, y0, angle);
-
-      double angleX, angleY;
-      is.GetR8(angleX);
-      is.GetR8(angleY);
-      dobj->SetSize(angleX, angleY);
-    }
-
-// On lit le DataBlock;
-  is >> dobj->DataBlock();
-}
-
-//++
-template <class T>
-void FIO_LocalMap<T>::WriteSelf(POutPersist& os) const
-//
-//--
-{
-  if(dobj == NULL) 
-    {
-      cout << " FIO_LocalMap::WriteSelf:: dobj= null " << endl;
-      return;
-    }
-
-  char strg[256];
-  int nSzX= dobj->Size_x();
-  int nSzY= dobj->Size_y();
-  int nPix= dobj->NbPixels();
- 
-  if(dobj->ptrInfo()) 
-    {
-      sprintf(strg,"LocalMap: NPixX=%6d  NPixY=%9d HasInfo",nSzX,nSzY);
-      os.PutLine(strg);
-      os << dobj->Info();
-    }
-  else 
-    { 
-      sprintf(strg,"LocalMap: NPixX=%6d  NPixY=%9d ",nSzX,nSzY);
-      os.PutLine(strg);  
-    }
-
-  os.PutI4(nSzX);
-  os.PutI4(nSzY);
-  os.PutI4(nPix);
-
-  if(dobj->LocalMap_isDone())
-    {
-      string ss("local mapping is done");
-      os.PutStr(ss);
-      int x0, y0;
-      double theta, phi, angle;
-      dobj->Origin(theta, phi, x0, y0, angle);
-      os.PutI4(x0);
-      os.PutI4(y0);
-      os.PutR8(theta);
-      os.PutR8(phi);
-      os.PutR8(angle);
-
-      double angleX, angleY;
-      dobj->Aperture(angleX, angleY);
-      os.PutR8(angleX);
-      os.PutR8(angleY);
-    }
-  else
-    {
-      string ss("no local mapping");
-      os.PutStr(ss);
-    }
-
-// On ecrit le dataBlock 
-  os << dobj->DataBlock();
-}
-
Index: trunk/SophyaLib/Samba/localmap.h
===================================================================
--- trunk/SophyaLib/Samba/localmap.h	(revision 681)
+++ trunk/SophyaLib/Samba/localmap.h	(revision 682)
@@ -65,5 +65,5 @@
 
 LocalMap();
-LocalMap(int nx, int ny);
+LocalMap(int_4 nx, int_4 ny);
 LocalMap(const LocalMap<T>& lm, bool share=false);
 virtual ~LocalMap();
@@ -71,8 +71,8 @@
 // ---------- Overloading of () to access pixel number k ----
 
-inline T& operator()(int k) {return(PixVal(k));}
-inline T const& operator()(int k) const {return(PixVal(k));}
-inline T& operator()(int ix, int iy) {return PixVal(iy*nSzX_+ix);};
-inline T const& operator()(int ix, int iy) const {return PixVal(iy*nSzX_+ix);};
+inline T& operator()(int_4 k) {return(PixVal(k));}
+inline T const& operator()(int_4 k) const {return(PixVal(k));}
+inline T& operator()(int_4 ix, int_4 iy) {return PixVal(iy*nSzX_+ix);};
+inline T const& operator()(int_4 ix, int_4 iy) const {return PixVal(iy*nSzX_+ix);};
    
 // ---------- Definition of PixelMap abstract methods -------
@@ -80,12 +80,12 @@
 /* return/set the number of pixels */
 /*!    Return number of pixels */
-virtual int NbPixels() const;
-inline void setNbPixels(int n) {nPix_= n;}
+virtual int_4 NbPixels() const;
+inline void setNbPixels(int_4 n) {nPix_= n;}
   
 /* return the value of pixel number k */
 /*!    Return value of pixel with index k */
-virtual T& PixVal(int k);
+virtual T& PixVal(int_4 k);
 /*!   const version of previous method */
-virtual T const& PixVal(int k) const;
+virtual T const& PixVal(int_4 k) const;
 
 /* Return true if teta,phi in map  */
@@ -93,9 +93,9 @@
 /* return the index of pixel at (theta,phi) */
 /*!    Return index of the pixel with spherical coordinates (theta,phi) */
-virtual int PixIndexSph(double theta,double phi) const;
+virtual int_4 PixIndexSph(double theta,double phi) const;
    
 /* return the spherical coordinates of center of pixel number k */
 /*!    Return (theta, phi) coordinates of pixel with index k */
-virtual void PixThetaPhi(int k,double& theta,double& phi) const;
+virtual void PixThetaPhi(int_4 k,double& theta,double& phi) const;
 
 /*! Set all pixels to value v */
@@ -108,10 +108,10 @@
     because of the projection scheme which is not yet fixed. 
 */  
-virtual double PixSolAngle(int k) const; 
+virtual double PixSolAngle(int_4 k) const; 
 
 // ---------- Specific methods ------------------------------
 
 /*!    Resize storage area for pixels */
-void ReSize(int nx, int ny);
+void ReSize(int_4 nx, int_4 ny);
 
 inline virtual char* TypeOfMap() const {return "LOCAL";};
@@ -124,5 +124,5 @@
 virtual void SetOrigin(double theta=90.,double phi=0.,double angle=0.);
 /*!    set the referential of the map (angles in degrees) */
-virtual void SetOrigin(double theta,double phi,int x0,int y0,double angle=0.);
+virtual void SetOrigin(double theta,double phi,int_4 x0,int_4 y0,double angle=0.);
 
 /* Pixel size (degres) */ 
@@ -140,13 +140,13 @@
   
 /* provides a integer characterizing the pixelization refinement  (here : number of pixels) */
-inline virtual int SizeIndex() const {return(nPix_);}
-inline int Size_x() const {return nSzX_;}
-inline int XSize() const {return nSzX_;}
-inline void setSize_x(int n) {nSzX_= n;}
-inline int Size_y() const {return nSzY_;}
-inline int YSize() const {return nSzY_;}
-inline void setSize_y(int n) {nSzY_= n;}
-
-inline void Origin(double& theta,double& phi,int& x0,int& y0,double& angle) const {theta= theta0_; phi= phi0_; x0= x0_; y0= y0_;angle= angle_;}
+inline virtual int_4 SizeIndex() const {return(nPix_);}
+inline int_4 Size_x() const {return nSzX_;}
+inline int_4 XSize() const {return nSzX_;}
+inline void setSize_x(int_4 n) {nSzX_= n;}
+inline int_4 Size_y() const {return nSzY_;}
+inline int_4 YSize() const {return nSzY_;}
+inline void setSize_y(int_4 n) {nSzY_= n;}
+
+inline void Origin(double& theta,double& phi,int_4& x0,int_4& y0,double& angle) const {theta= theta0_; phi= phi0_; x0= x0_; y0= y0_;angle= angle_;}
 
 inline void Aperture(double& anglex,double& angley) const {anglex= angleX_; angley= angleY_;}
@@ -154,5 +154,5 @@
 /* retourne le pointeur vers/remplit  le vecteur des contenus des pixels */ 
 inline const NDataBlock<T>* getDataBlock() const {return (&pixels_);}
-inline void setDataBlock(T* data, int n) {pixels_.FillFrom(n,data);}
+inline void setDataBlock(T* data, int_4 n) {pixels_.FillFrom(n,data);}
 
 /*  Acces to the DataBlock  */
@@ -169,5 +169,5 @@
 void InitNul();
 /*!    Return 2 indices corresponding to the pixel number k */
-void Getij(int k,int& i,int& j) const;
+void Getij(int_4 k,int_4& i,int_4& j) const;
 /*!    Transform a pair of coordinates (theta, phi) given in 
     reference coordinates into map coordinates
@@ -189,11 +189,11 @@
 // ---------- Variables internes ----------------------------
 
-int nSzX_;
-int nSzY_;
-int nPix_;
+int_4 nSzX_;
+int_4 nSzY_;
+int_4 nPix_;
 bool originFlag_;
 bool extensFlag_;
-int x0_;
-int y0_;
+int_4 x0_;
+int_4 y0_;
 double theta0_;
 double phi0_;
Index: trunk/SophyaLib/Samba/pixelmap.h
===================================================================
--- trunk/SophyaLib/Samba/pixelmap.h	(revision 681)
+++ trunk/SophyaLib/Samba/pixelmap.h	(revision 682)
@@ -36,9 +36,9 @@
 
 /*! Number of pixels */
-virtual int NbPixels() const=0;
+virtual int_4 NbPixels() const=0;
    
 /*! Value of pixel number k */
-virtual T& PixVal(int k)=0;
-virtual T const& PixVal(int k) const=0;
+virtual T& PixVal(int_4 k)=0;
+virtual T const& PixVal(int_4 k) const=0;
 
 // Map s coverage
@@ -47,7 +47,7 @@
 
 /*! Index of pixel at (theta,phi) */
-virtual int PixIndexSph(double theta, double phi) const=0;
+virtual int_4 PixIndexSph(double theta, double phi) const=0;
 // Index of pixel at a sky-position 
-virtual int PixIndex(const SpherePosition& spos);
+virtual int_4 PixIndex(const SpherePosition& spos);
 
 /*! Value of pixel number at (theta,phi) */
@@ -58,18 +58,18 @@
 
 /*! Spherical coordinates of center of pixel number k */
-virtual void PixThetaPhi(int k, double& theta, double& phi) const=0;
+virtual void PixThetaPhi(int_4 k, double& theta, double& phi) const=0;
 
 /*! provides a integer characterizing the pixelization refinement 
  (depending of the type of the map) 
 */             
-virtual int SizeIndex() const=0;
+virtual int_4 SizeIndex() const=0;
 virtual char* TypeOfMap() const =0;
 
 /*! Pixel  (steradians) */
-virtual double PixSolAngle(int k) const =0; 
+virtual double PixSolAngle(int_4 k) const =0; 
 
 /*! Overloading of () to access pixel number k. */
-inline T& operator()(int k) {return(PixVal(k));}
-inline T const& operator()(int k) const {return(PixVal(k));}
+inline T& operator()(int_4 k) {return(PixVal(k));}
+inline T const& operator()(int_4 k) const {return(PixVal(k));}
 
 // Overloading of () to access pixel at a sky position .
@@ -110,5 +110,5 @@
 
 template <class T>
-int PixelMap<T>::PixIndex(const SpherePosition& spos)
+int_4 PixelMap<T>::PixIndex(const SpherePosition& spos)
 {
 UnitVector v = spos.Transform(*cs_);
Index: trunk/SophyaLib/Samba/scan.cc
===================================================================
--- trunk/SophyaLib/Samba/scan.cc	(revision 681)
+++ trunk/SophyaLib/Samba/scan.cc	(revision 682)
@@ -352,5 +352,5 @@
 {
 
-  int NmaxPts, NmaxTrs, NPts1Tr;
+  int_4 NmaxPts, NmaxTrs, NPts1Tr;
   r_4 Ouverture, OmegaTeta, OmegaPhi, OmegaRad, FrequenceEch; 
   r_4 TempsFinal,  TempsInitial, PhiZero; 
Index: trunk/SophyaLib/Samba/spheregorski.cc
===================================================================
--- trunk/SophyaLib/Samba/spheregorski.cc	(revision 681)
+++ trunk/SophyaLib/Samba/spheregorski.cc	(revision 682)
@@ -186,5 +186,5 @@
 //++
 template<class T>
-SphereGorski<T>::SphereGorski(int m)
+SphereGorski<T>::SphereGorski(int_4 m)
 
 //    m is the "nside" of the Gorski algorithm
@@ -246,5 +246,5 @@
 //++
 template<class T>
-void SphereGorski<T>::Resize(int m)
+void SphereGorski<T>::Resize(int_4 m)
 
 //    m is the "nside" of the Gorski algorithm
@@ -272,5 +272,5 @@
 
 template<class T>
-void  SphereGorski<T>::Pixelize( int m) 
+void  SphereGorski<T>::Pixelize( int_4 m) 
 
 //    prépare la pixelisation Gorski (m a la même signification 
@@ -313,5 +313,5 @@
 //++
 template<class T>
-int SphereGorski<T>::NbPixels() const
+int_4 SphereGorski<T>::NbPixels() const
 
 //    Retourne le nombre de pixels du découpage
@@ -323,5 +323,5 @@
 //++
 template<class T>
-int SphereGorski<T>::NbThetaSlices() const 
+int_4 SphereGorski<T>::NbThetaSlices() const 
 
 //    Return number of slices in theta direction on the  sphere
@@ -333,5 +333,5 @@
 //++
 template<class T>
-void SphereGorski<T>::GetThetaSlice(int index,double& theta,TVector<double>& phi,TVector<T>& value) const 
+void SphereGorski<T>::GetThetaSlice(int_4 index,double& theta,TVector<double>& phi,TVector<T>& value) const 
 
 //    For a theta-slice with index 'index', return : 
@@ -354,6 +354,6 @@
     }
 
-  int iring= 0;
-  int lring  = 0;
+  int_4 iring= 0;
+  int_4 lring  = 0;
   if(index < nSide_-1) 
     {
@@ -368,5 +368,5 @@
   else
     {
-      int nc= 4*nSide_-1-index;
+      int_4 nc= 4*nSide_-1-index;
       iring = nPix_-2*nc*(nc+1);
       lring = 4*nc;
@@ -377,5 +377,5 @@
   double TH= 0.;
   double FI= 0.;
-  for(int kk = 0; kk < lring;kk++) 
+  for(int_4 kk = 0; kk < lring;kk++) 
     {
       PixThetaPhi(kk+iring,TH,FI);
@@ -389,5 +389,5 @@
 //++
 template<class T>
-T& SphereGorski<T>::PixVal(int k)
+T& SphereGorski<T>::PixVal(int_4 k)
 
 //    Return value of  pixel with "RING" index k 
@@ -406,5 +406,5 @@
 //++
 template<class T>
-T const& SphereGorski<T>::PixVal(int k) const
+T const& SphereGorski<T>::PixVal(int_4 k) const
 
 //    Return value of  pixel with "RING" index k 
@@ -422,5 +422,5 @@
 //++
 template<class T>
-T& SphereGorski<T>::PixValNest(int k)
+T& SphereGorski<T>::PixValNest(int_4 k)
 
 //    Return value of  pixel with "NESTED" index k 
@@ -438,5 +438,5 @@
 
 template<class T>
-T const& SphereGorski<T>::PixValNest(int k) const
+T const& SphereGorski<T>::PixValNest(int_4 k) const
 
 //    Return value of  pixel with "NESTED" index k 
@@ -449,5 +449,5 @@
       THROW(rangeCheckErr);
   }
-  int pix= nest2ring(nSide_,k);
+  int_4 pix= nest2ring(nSide_,k);
   return *(pixels_.Data()+pix);
 }
@@ -456,5 +456,5 @@
 //++
 template<class T>
-bool SphereGorski<T>::ContainsSph(double theta, double phi) const
+bool SphereGorski<T>::ContainsSph(double /*theta*/, double /*phi*/) const
 //--
 {
@@ -465,5 +465,5 @@
 //++
 template<class T>
-int SphereGorski<T>::PixIndexSph(double theta,double phi) const
+int_4 SphereGorski<T>::PixIndexSph(double theta,double phi) const
 
 //    Return "RING" index of the pixel corresponding to 
@@ -476,5 +476,5 @@
 //++
 template<class T>
-int SphereGorski<T>::PixIndexSphNest(double theta,double  phi) const
+int_4 SphereGorski<T>::PixIndexSphNest(double theta,double  phi) const
 
 //    Return "NESTED" index of the pixel corresponding to 
@@ -489,5 +489,5 @@
 //++
 template<class T>
-void SphereGorski<T>::PixThetaPhi(int k,double& theta,double& phi) const
+void SphereGorski<T>::PixThetaPhi(int_4 k,double& theta,double& phi) const
 
 //   Return (theta,phi) coordinates of middle of  pixel with "RING" index k
@@ -506,5 +506,5 @@
 //++
 template<class T>
-double SphereGorski<T>::PixSolAngle(int dummy) const
+double SphereGorski<T>::PixSolAngle(int_4 /*dummy*/) const
 //    Pixel Solid angle  (steradians)
 //    All the pixels have the same solid angle. The dummy argument is
@@ -518,5 +518,5 @@
 //++
 template<class T>
-void SphereGorski<T>::PixThetaPhiNest(int k,double& theta,double& phi) const
+void SphereGorski<T>::PixThetaPhiNest(int_4 k,double& theta,double& phi) const
 
 //   Return (theta,phi) coordinates of middle of  pixel with "NESTED" index k
@@ -528,5 +528,5 @@
 //++
 template<class T>
-int SphereGorski<T>::NestToRing(int k) const
+int_4 SphereGorski<T>::NestToRing(int_4 k) const
 
 //    translation from NESTED index  into RING index 
@@ -539,5 +539,5 @@
 //++
 template<class T>
-int SphereGorski<T>::RingToNest(int k) const
+int_4 SphereGorski<T>::RingToNest(int_4 k) const
 //
 //    translation from  RING index  into NESTED index 
@@ -550,5 +550,5 @@
 
 template<class T>
-int SphereGorski<T>::nest2ring(int nside, int ipnest) const 
+int_4 SphereGorski<T>::nest2ring(int_4 nside, int_4 ipnest) const 
 {
   /*
@@ -632,5 +632,5 @@
 
 template<class T>
-int SphereGorski<T>::ring2nest(int nside, int ipring) const 
+int_4 SphereGorski<T>::ring2nest(int_4 nside, int_4 ipring) const 
 {
   /*
@@ -741,5 +741,5 @@
 
 template<class T>
-int SphereGorski<T>::ang2pix_ring(int nside, double theta, double phi) const 
+int_4 SphereGorski<T>::ang2pix_ring(int_4 nside, double theta, double phi) const 
 {
   /*
@@ -817,5 +817,5 @@
 
 template<class T>
-int SphereGorski<T>::ang2pix_nest(int nside, double theta, double phi) const 
+int_4 SphereGorski<T>::ang2pix_nest(int_4 nside, double theta, double phi) const 
 {
   /*
@@ -914,5 +914,5 @@
 
 template<class T>
-void SphereGorski<T>::pix2ang_ring(int nside,int ipix,double& theta,double& phi) const {
+void SphereGorski<T>::pix2ang_ring(int_4 nside,int_4 ipix,double& theta,double& phi) const {
   /*
     ===================================================
@@ -982,5 +982,5 @@
 
 template<class T>
-void SphereGorski<T>::pix2ang_nest(int nside,int ipix,double& theta,double& phi) const {
+void SphereGorski<T>::pix2ang_nest(int_4 nside,int_4 ipix,double& theta,double& phi) const {
   /*
     ==================================================
@@ -1174,9 +1174,9 @@
     }
 
-  int nSide;
+  int_4 nSide;
   is.GetI4(nSide);
   dobj->setSizeIndex(nSide);
 
-  int nPix;
+  int_4 nPix;
   is.GetI4(nPix);
   dobj->setNbPixels(nPix);
@@ -1204,6 +1204,6 @@
 
   char strg[256];
-  int nSide= dobj->SizeIndex();
-  int nPix = dobj->NbPixels();
+  int_4 nSide= dobj->SizeIndex();
+  int_4 nPix = dobj->NbPixels();
  
   if(dobj->ptrInfo()) 
